"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
Object.defineProperty(exports, "__esModule", { value: true });
exports.customBotGen = void 0;
const BotGenerator_1 = require("C:/snapshot/project/obj/generators/BotGenerator");
const BotDifficultyHelper_1 = require("C:/snapshot/project/obj/helpers/BotDifficultyHelper");
const BotHelper_1 = require("C:/snapshot/project/obj/helpers/BotHelper");
const ProfileHelper_1 = require("C:/snapshot/project/obj/helpers/ProfileHelper");
const WeightedRandomHelper_1 = require("C:/snapshot/project/obj/helpers/WeightedRandomHelper");
const ILogger_1 = require("C:/snapshot/project/obj/models/spt/utils/ILogger");
const ConfigServer_1 = require("C:/snapshot/project/obj/servers/ConfigServer");
const DatabaseServer_1 = require("C:/snapshot/project/obj/servers/DatabaseServer");
const BotEquipmentFilterService_1 = require("C:/snapshot/project/obj/services/BotEquipmentFilterService");
const LocalisationService_1 = require("C:/snapshot/project/obj/services/LocalisationService");
const SeasonalEventService_1 = require("C:/snapshot/project/obj/services/SeasonalEventService");
const HashUtil_1 = require("C:/snapshot/project/obj/utils/HashUtil");
const JsonUtil_1 = require("C:/snapshot/project/obj/utils/JsonUtil");
const RandomUtil_1 = require("C:/snapshot/project/obj/utils/RandomUtil");
const TimeUtil_1 = require("C:/snapshot/project/obj/utils/TimeUtil");
const BotInventoryGenerator_1 = require("C:/snapshot/project/obj/generators/BotInventoryGenerator");
const BotLevelGenerator_1 = require("C:/snapshot/project/obj/generators/BotLevelGenerator");
const tsyringe_1 = require("C:/snapshot/project/node_modules/tsyringe");
let customBotGen = class customBotGen extends BotGenerator_1.BotGenerator {
    logger;
    hashUtil;
    randomUtil;
    timeUtil;
    jsonUtil;
    profileHelper;
    databaseServer;
    botInventoryGenerator;
    botLevelGenerator;
    botEquipmentFilterService;
    weightedRandomHelper;
    botHelper;
    botDifficultyHelper;
    seasonalEventService;
    localisationService;
    configServer;
    constructor(logger, hashUtil, randomUtil, timeUtil, jsonUtil, profileHelper, databaseServer, botInventoryGenerator, botLevelGenerator, botEquipmentFilterService, weightedRandomHelper, botHelper, botDifficultyHelper, seasonalEventService, localisationService, configServer) {
        super(logger, hashUtil, randomUtil, timeUtil, jsonUtil, profileHelper, databaseServer, botInventoryGenerator, botLevelGenerator, botEquipmentFilterService, weightedRandomHelper, botHelper, botDifficultyHelper, seasonalEventService, localisationService, configServer);
        this.logger = logger;
        this.hashUtil = hashUtil;
        this.randomUtil = randomUtil;
        this.timeUtil = timeUtil;
        this.jsonUtil = jsonUtil;
        this.profileHelper = profileHelper;
        this.databaseServer = databaseServer;
        this.botInventoryGenerator = botInventoryGenerator;
        this.botLevelGenerator = botLevelGenerator;
        this.botEquipmentFilterService = botEquipmentFilterService;
        this.weightedRandomHelper = weightedRandomHelper;
        this.botHelper = botHelper;
        this.botDifficultyHelper = botDifficultyHelper;
        this.seasonalEventService = seasonalEventService;
        this.localisationService = localisationService;
        this.configServer = configServer;
    }
    generate(sessionId, bot, botJsonTemplate, botGenerationDetails) {
        const botRole = botGenerationDetails.role.toLowerCase();
        const botLevel = this.botLevelGenerator.generateBotLevel(botJsonTemplate.experience.level, botGenerationDetails, bot);
        var botPMC = false;
        for (let type in botGenerationDetails.conditions) {
            let roles = botGenerationDetails.conditions[type];
            if (roles.Role == "pmcBot") {
                botPMC = true;
            }
        }
        bot.Info.Nickname = this.generateBotNickname(botJsonTemplate, botGenerationDetails.isPlayerScav, botRole, sessionId);
        if (!botGenerationDetails.isPlayerScav) {
            this.botEquipmentFilterService.getBotEquipmentBlacklist(botRole, botLevel.level);
            this.botEquipmentFilterService.filterBotEquipment(botJsonTemplate, botLevel.level, botPMC, botRole);
        }
        const skipChristmasItems = !this.seasonalEventService.christmasEventEnabled();
        if (skipChristmasItems) {
            this.seasonalEventService.removeChristmasItemsFromBotInventory(botJsonTemplate.inventory, botGenerationDetails.role);
        }
        // Remove hideout data if bot is not a PMC or pscav
        if (!(botGenerationDetails.isPmc || botGenerationDetails.isPlayerScav)) {
            bot.Hideout = null;
        }
        bot.Info.Experience = botLevel.exp;
        bot.Info.Level = botLevel.level;
        bot.Info.Settings.Experience = this.randomUtil.getInt(botJsonTemplate.experience.reward.min, botJsonTemplate.experience.reward.max);
        bot.Info.Settings.StandingForKill = botJsonTemplate.experience.standingForKill;
        bot.Info.Voice = this.randomUtil.getArrayValue(botJsonTemplate.appearance.voice);
        bot.Health = this.generateHealth(botJsonTemplate.health, bot.Info.Side === "Savage");
        bot.Skills = this.generateSkills(botJsonTemplate.skills); // TODO: fix bad type, bot jsons store skills in dict, output needs to be array
        // START CUSTOM BOT GEN CODE
        const dbServer = this.databaseServer.getTables();
        const addClothingToBots = dbServer.bots.botClothingGen.addClothingToBots;
        const clothingTags = dbServer.bots.botClothingGen.tags;
        const clothingTagWeights = dbServer.bots.botClothingGen.weights;
        const customClothingBotTypes = dbServer.bots.botClothingGen.botTypes;
        const customClothingChance = dbServer.bots.botClothingGen.rollWeights;
        function defaultClothingGen(weightedRandomHelper) {
            bot.Customization.Body = weightedRandomHelper.getWeightedInventoryItem(botJsonTemplate.appearance.body);
            bot.Customization.Feet = weightedRandomHelper.getWeightedInventoryItem(botJsonTemplate.appearance.feet);
        }
        // tags without atleast 1 item in bottoms AND top will be rerolled.
        // reroll is our base case and stops the function from endlessly calling itself if all the tags dont have a matching set.
        function getMatchingSet(weightedRandomHelper, reroll = 0) {
            const chosenTag = weightedRandomHelper.getWeightedInventoryItem(clothingTagWeights);
            if ("tops" in clothingTags[chosenTag] && "bottoms" in clothingTags[chosenTag]) {
                bot.Customization.Body = weightedRandomHelper.getWeightedInventoryItem(clothingTags[chosenTag]["tops"]);
                bot.Customization.Feet = weightedRandomHelper.getWeightedInventoryItem(clothingTags[chosenTag]["bottoms"]);
            }
            else {
                if (Object.keys(clothingTags).length >= 2 && reroll <= 3) {
                    reroll++;
                    getMatchingSet(weightedRandomHelper, reroll);
                }
                else {
                    defaultClothingGen(weightedRandomHelper);
                }
            }
        }
        if (addClothingToBots) {
            const rolledWeightValue = this.weightedRandomHelper.getWeightedInventoryItem(customClothingChance);
            if (rolledWeightValue == "custom" && customClothingBotTypes.includes(botRole) && Object.keys(clothingTagWeights).length >= 1) {
                getMatchingSet(this.weightedRandomHelper);
            }
            else {
                defaultClothingGen(this.weightedRandomHelper);
            }
        }
        else {
            defaultClothingGen(this.weightedRandomHelper);
        }
        // END CUSTOM BOT GEN CODE
        bot.Customization.Head = this.randomUtil.getArrayValue(botJsonTemplate.appearance.head);
        bot.Customization.Hands = this.randomUtil.getArrayValue(botJsonTemplate.appearance.hands);
        bot.Inventory = this.botInventoryGenerator.generateInventory(sessionId, botJsonTemplate, botRole, botGenerationDetails.isPmc, botLevel.level);
        if (this.botHelper.isBotPmc(botRole)) {
            this.getRandomisedGameVersionAndCategory(bot.Info);
            bot = this.generateDogtag(bot);
        }
        // generate new bot ID
        bot = this.generateId(bot);
        // generate new inventory ID
        bot = this.generateInventoryID(bot);
        return bot;
    }
};
exports.customBotGen = customBotGen;
exports.customBotGen = customBotGen = __decorate([
    (0, tsyringe_1.injectable)(),
    __param(0, (0, tsyringe_1.inject)("WinstonLogger")),
    __param(1, (0, tsyringe_1.inject)("HashUtil")),
    __param(2, (0, tsyringe_1.inject)("RandomUtil")),
    __param(3, (0, tsyringe_1.inject)("TimeUtil")),
    __param(4, (0, tsyringe_1.inject)("JsonUtil")),
    __param(5, (0, tsyringe_1.inject)("ProfileHelper")),
    __param(6, (0, tsyringe_1.inject)("DatabaseServer")),
    __param(7, (0, tsyringe_1.inject)("BotInventoryGenerator")),
    __param(8, (0, tsyringe_1.inject)("BotLevelGenerator")),
    __param(9, (0, tsyringe_1.inject)("BotEquipmentFilterService")),
    __param(10, (0, tsyringe_1.inject)("WeightedRandomHelper")),
    __param(11, (0, tsyringe_1.inject)("BotHelper")),
    __param(12, (0, tsyringe_1.inject)("BotDifficultyHelper")),
    __param(13, (0, tsyringe_1.inject)("SeasonalEventService")),
    __param(14, (0, tsyringe_1.inject)("LocalisationService")),
    __param(15, (0, tsyringe_1.inject)("ConfigServer")),
    __metadata("design:paramtypes", [typeof (_a = typeof ILogger_1.ILogger !== "undefined" && ILogger_1.ILogger) === "function" ? _a : Object, typeof (_b = typeof HashUtil_1.HashUtil !== "undefined" && HashUtil_1.HashUtil) === "function" ? _b : Object, typeof (_c = typeof RandomUtil_1.RandomUtil !== "undefined" && RandomUtil_1.RandomUtil) === "function" ? _c : Object, typeof (_d = typeof TimeUtil_1.TimeUtil !== "undefined" && TimeUtil_1.TimeUtil) === "function" ? _d : Object, typeof (_e = typeof JsonUtil_1.JsonUtil !== "undefined" && JsonUtil_1.JsonUtil) === "function" ? _e : Object, typeof (_f = typeof ProfileHelper_1.ProfileHelper !== "undefined" && ProfileHelper_1.ProfileHelper) === "function" ? _f : Object, typeof (_g = typeof DatabaseServer_1.DatabaseServer !== "undefined" && DatabaseServer_1.DatabaseServer) === "function" ? _g : Object, typeof (_h = typeof BotInventoryGenerator_1.BotInventoryGenerator !== "undefined" && BotInventoryGenerator_1.BotInventoryGenerator) === "function" ? _h : Object, typeof (_j = typeof BotLevelGenerator_1.BotLevelGenerator !== "undefined" && BotLevelGenerator_1.BotLevelGenerator) === "function" ? _j : Object, typeof (_k = typeof BotEquipmentFilterService_1.BotEquipmentFilterService !== "undefined" && BotEquipmentFilterService_1.BotEquipmentFilterService) === "function" ? _k : Object, typeof (_l = typeof WeightedRandomHelper_1.WeightedRandomHelper !== "undefined" && WeightedRandomHelper_1.WeightedRandomHelper) === "function" ? _l : Object, typeof (_m = typeof BotHelper_1.BotHelper !== "undefined" && BotHelper_1.BotHelper) === "function" ? _m : Object, typeof (_o = typeof BotDifficultyHelper_1.BotDifficultyHelper !== "undefined" && BotDifficultyHelper_1.BotDifficultyHelper) === "function" ? _o : Object, typeof (_p = typeof SeasonalEventService_1.SeasonalEventService !== "undefined" && SeasonalEventService_1.SeasonalEventService) === "function" ? _p : Object, typeof (_q = typeof LocalisationService_1.LocalisationService !== "undefined" && LocalisationService_1.LocalisationService) === "function" ? _q : Object, typeof (_r = typeof ConfigServer_1.ConfigServer !== "undefined" && ConfigServer_1.ConfigServer) === "function" ? _r : Object])
], customBotGen);
